
// *** BROWSER VERSION *** 
var ver = navigator.appVersion.toLowerCase();
var agt = navigator.userAgent.toLowerCase(); 
var isWin = (-1 != ver.indexOf( "win" ) ); 
var isMac = (-1 != ver.indexOf( "mac" ) ); 
// Note: On IE5, these return 4, so use is_ie5up to detect IE5. 
var is_major = parseInt( ver ); 
var is_minor = parseFloat( ver ); 
// Note: Opera and WebTV spoof Navigator.  We do strict client detection. 
// If you want to allow spoofing, take out the tests for opera and webtv. 
var isNav  = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1) 
            && (agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1) 
            && (agt.indexOf('webtv')==-1)); 
var is_nav2 = (isNav && (is_major == 2)); 
var is_nav3 = (isNav && (is_major == 3)); 
var isNav4 = (isNav && (is_major == 4)); 
var is_nav4up = (isNav && (is_major >= 4)); 
var is_nav5 = (isNav && (is_major == 5)); 
var is_nav5up = (isNav && (is_major >= 5)); 
var isNav5Up = (isNav && (is_major >= 5)); 
var isIE   = (agt.indexOf("msie") != -1); 
var is_ie3  = (isIE && (is_major < 4)); 
var is_ie4  = (isIE && (is_major == 4) && (agt.indexOf("msie 5.")==-1) ); 
var isIE4Up  = (isIE  && (is_major >= 4)); 
var is_ie5  = (isIE && (is_major == 4) && (agt.indexOf("msie 5.0")!=-1) ); 
var isIE5Up  = (isIE  && !is_ie3 && !is_ie4); 
// shortcut to Classes loaded in the top window
PropObj = top.PropObj ;
PropList = top.PropList ;
EditSelect = top.EditSelect ;

if ( window.name == "Main" )
{
	top.fMainFrameIsLocal = true ;
}
function isObj ( objToTest )
{
	return ( (objToTest != null) &&
			 (typeof(objToTest) == "object") );
}
function rejectInput ( ctrl, errMsg )
{
	function _doFocus ()
	{
		var ctrl = rejectInput.ctrl ;
		if ( ctrl && (typeof( ctrl ) == "object") )
		{
			if ( ctrl.type != "hidden" )
				ctrl.focus();
			if ( ctrl.type == "text" )
				ctrl.select();
		}
	}
	if ( errMsg ) alert( errMsg );
	/*
		In Navigator, if the focus is set to control 'B' while in the
		middle of processing an onchange event for control 'A', another
		onchange event will be fired for control 'A' - that's bad. 
		The workaround is to delay the execution of the focus() method by using
		setTimeout().
	*/
	rejectInput.ctrl = ctrl ;
	if ( isNav ) window.setTimeout( "rejectInput._doFocus()", 100 );
	else _doFocus();
	return false ;
}
function getCtrlValue ( ctrl, bUseSelectText )
{
	switch( ctrl.type )
	{
		case "text" :
		case "textarea" :
		case "hidden":
		case "password":
		case "submit":
		case "reset":
			return ctrl.value.trim() ;
		case "checkbox":
			return ctrl.checked ? "1" : "0" ;
		case "select-one" :
		case "select-multiple" :
		{
			if ( -1 == ( ctrl.selectedIndex ) )	
				return "" ;
			return bUseSelectText ? 
				ctrl.options[ ctrl.selectedIndex ].text : 
				ctrl.options[ ctrl.selectedIndex ].value ;
		}
		default:
			alert( "getCtrlValue(): Control type Not Implemented: " + ctrl.type + "\ncontrol name = " + ctrl.name );
			return "" ;
	}	// switch( ctrl.type )
}	// getCtrlValue ()
function setCtrlValue ( ctrl, value )
{
	switch( ctrl.type )
	{
		case "text" :
		case "textarea" :
		case "hidden" :
		case "password" :
		    ctrl.value = value ;
			break;
		/* for select lists, find and select the option whose
		   VALUE == this.m_props[ prop ].value
		   TODO: set/get multiple choices for select-multiple controls
		*/
		case "select-one" :
		case "select-multiple" :
			if ( isIE ) 
			{
				ctrl.value = value ;
			}
			else
			{
				for ( var i=0; i < ctrl.length; i++ )
				{
				    if ( ctrl.options[i].value == value )
					{
						ctrl.selectedIndex = i ;

						break ;
					}
				}
			}
			break;
		case "checkbox":
			ctrl.checked = 
			   ( (value != null ) && 
				 (value != false) &&
				 (value != "0"	) &&
				 (value != 0	) &&
				 (value != ""	) );
			break;
		default:
			alert( "setCtrlValue(): Control type Not Implemented: " + ctrl.type + "\ncontrol name = " + ctrl.name );
	}	// swtich( ctrl.type )
}	// setCtrlValue ()
function clearForm ( f )
{
	if ( ! (f && f.elements && f.elements.length) )
		return ;
	var ctrl;
	for ( var i = 0; i < f.elements.length; i++ )
	{
		ctrl = f.elements[ i ];
		switch( ctrl[ "type" ] )
		{
			case "text" :
			case "textarea" :
			case "hidden" :
			case "password" :
			    ctrl.value = "" ;
				break;
			/* select the original default option
			*/
			case "select-one" :
			case "select-multiple" :
			{
				var selX = 0;
				for ( var x = 0; x < ctrl.options.length; x++ )
				{
				    if ( ctrl.options[x][ "defaultSelected" ] )
					{
						selX = x ;
						break ;
					}
				}
	 			ctrl.selectedIndex = selX ;
				break;
			}
			case "checkbox":
				ctrl.checked = ctrl[ "defaultChecked" ];
				break;
			default:
				break ;
		}	// swtich( ctrl.type )
	}
}	// clearForm ()
//deletes index option from select list, or deletes currently selected option
//if index == null 
function selectDel ( ctrl, index )
{
	var curSelX = ctrl.selectedIndex ;
	if ( index == null ) index = curSelX ;
	if ( ctrl.length && (index >= 0) && (index < ctrl.length) )
	{
		ctrl.options[ index ] = null ;
		if ( index <= curSelX )
			ctrl.selectedIndex = curSelX - 1
	}
}	// selectDel()
// select the first element of a <SELECT> list box
// in IE, after resetting the list, selecting index 0 doesn't work if that was the last selection (I think)
// work-around is to set index to 1, then 0
function selectFirst ( ctrl )
{
	if ( isIE )
	    ctrl.selectedIndex = 1;
    ctrl.selectedIndex = 0;
}
/*
	Enumerates a 'property' array (i.e. associative array)
	pass a callback function to enum func with this signature:
	someCallbackFunc( array, property , curDepth )
	return non-zero from your callback to halt the enumeration
*/
function enumPropArray ( a, callback, maxDepth )
{
	if ( ! ( a && callback ) ) return ;
	// default maxDepth is zero, i.e. full recursion
	if ( enumPropArray.arguments.length < 3 ) maxDepth = 0 ;
	function _enumProps( a, curDepth, curPath )
	{
		if ( maxDepth && ( curDepth >= maxDepth ) ) return ;
		for ( var x in a )
		{
			// if callback returns a non-zero value that's a signal to abort the
			// enumeration
		    if( callback( a, x, curDepth, curPath + ( curPath ? "." + x : x ) ) ) return ;
			if ( typeof( a[ x ] ) == "object" )
			{
				curPath += ( curPath ? "." + x : x );
				curDepth++ ;
				_enumProps( a[ x ], curDepth, curPath ) 
				curDepth-- ;
				curPath = curDepth ? curPath.leftProp( -1 ) : "" ;
			}
		}	
	}
	_enumProps( a, 0, "" );
}
/*********************************************************
window procs
*/
function openDialog
( 
	href,	// window src document
	name,	// optional window name (default = 'DIALOG')
	options	// optional window features (see window.open API, def = 'resizable=no,scrollbars=no,width=460,height=360,screenX=200,screenY=200,dependent')
)
{
	if ( ! href ) return null ; // can't do nuthin'
    var newWindow = null ;
	var defName = 'DIALOG' ;
	var defOptions = 'resizable=no,scrollbars=no,width=460,height=360,screenX=200,screenY=200,dependent' ;
	// set up defaults
	if ( ! options ) options = defOptions ;
	if ( ! name ) 	 name 	 = defName ;
    newWindow = window.open( href, name, options );
	// IE won't let us call focus method on the newWindow if its in another domain!
	// HACK: if a protocal//host is specified in the HREF, assume it's in another domain
	// HACK: no focus at all for IE with remote documentation
	//if ( newWindow && ( isNav || ( -1 == href.indexOf( ':' ) ) ) )
	if ( newWindow && isNav )
		newWindow.focus();
	return newWindow ;
}
/**********
	Help Window
*/
/* ------------ opens custom dialog box to display inline help --------------*/
var helpWinName = 'helpMe' ;
var helpWinOptions = 'toolbar=yes,status=no,scrollbars=yes,resizable=yes,menubar=yes,width=800,height=500,dependent' ;
function launchHelp( fileName, options )
{
	// stuff window ref in topmost parent window
	top.helpWin = openDialog( fileName, helpWinName, options ? options : helpWinOptions );
}
function launchHome( fileName, options )
{
	// opens external content in seperate window
	openDialog( fileName, "realHome", options ? options : helpWinOptions );
}
// call this function from any page to display its related help file/anchor
// TODO make this into a global object to cache helpWin reference
function contextHelp ( helpLink )
{
	if ( ! helpLink )
	{
		alert( "Documentation for this topic does not exist" );
		return ;
	}
	var docPath = "Docs/Manual/" ;
	var helpFrameset = "realsrvr.htm" ;
	// if our help window is already open, just switch to it and navigate 
	// to the bookmark
	var win = top.helpWin ;
	if ( isNav && win && win.body && (! win.closed) )	
	{
		win.focus();
		win.body.location.href = docPath + helpLink ;
	}
	else	// open help win and load help frameset, pass helpLink in querystring
	{
		if ( helpLink )
			helpFrameset += "?goto=" + escape( helpLink );
		win = top.helpWin = openDialog( docPath + helpFrameset, helpWinName, helpWinOptions );
	}
}	// contextHelp ()
function launchAbout ()
{
	openDialog( "license.nc.html", 'aboutMe', 'toolbar=no,status=no,scrollbars=yes,resizable=no,menubar=no,width=616,height=540' );
}
function findFrame ( frameName )
{

	return top[ frameName ];
}
function buildParam ( paramName, paramValue )
{

	return "&" + escape( paramName ) + "=" + escape( paramValue );
}
function sortCaseInsensitive ( a, b )
{
	if (a == null) return -1;
	if (b == null) return 1;
	if( (parseInt(a) == a) && 
	    (parseInt(b) == b) )
	{
	 	return ( parseInt(a) < parseInt(b) ? -1 : 1 );
	}
	else if( (typeof(a) == "number") && 
	    	 (typeof(b) == "number") )
	{
	 	return ( a < b ? -1 : 1 );
	}
	else
	{
		return ( a.toString().toLowerCase() < b.toString().toLowerCase() ? -1 : 1 );
	}
}
function testURL ( urlCtrl )
{
	var url = getCtrlValue( urlCtrl );
	if ( url && (url != "http://") )
	{
		window.open( url, "TEST_URL" );
	}
	else
	{
		rejectInput( urlCtrl, "Please enter a valid URL." );
	}
}
function activateLink ( urlCtrl, linkSpan )
{
	if ( isNav ) return ;
	if ( urlCtrl.value != "" )
	{
		if ( linkSpan.all.URL_LINK == null )
			linkSpan.innerHTML = "<A TITLE='Test the " + linkSpan.innerHTML + " in a seperate browser window' ID='URL_LINK' HREF='javascript:testURL( document.all." + urlCtrl.id + ")'>" + linkSpan.innerHTML + "</A>" ;
	}
	else
	{
		if ( linkSpan.all.URL_LINK )
			linkSpan.innerHTML = linkSpan.all.URL_LINK.innerHTML ;
	}
}

