
/* Globals */
var hwndDlg = null ;
var dlgParams = null ;
var oldOnFocus = null ;
var defOptions = 'status=no,resizable=no,dependant=yes,scrollbars=' ; // MUST append "yes" or "no" !!!!
function _configOnLoadDefault ( nextHandler )
{
	if ( isMac && isNav && document.MACFIX )
		document.MACFIX.hidden=true;
	if ( pendingChanges )
		doPendingChanges();
	// set frameset title to reflect main frame title
	if ( isIE ) 
		top.document.title = top.origTitle + " | " + document.title ; 
	if ( nextHandler )
		nextHandler();
}
function _configOnUnLoadDefault ( nextHandler )
{
	// reset frameset title
	if ( isIE && top.document.title ) 
		top.document.title = top.origTitle ;
	if ( nextHandler )
		nextHandler();
}
function doPendingChanges ()
{
	var headerFrame = findFrame( "Header" );
	var img = document.RESTART_IMG ;
	if ( img && headerFrame )
	{
		var imgSpan = ( isNav ? null : document.all.RESTART_IMG_SPAN );
		headerFrame.restartImage( img, imgSpan );
	}
}
function raSubmitChanges
( 
	chgType,			// "servvar" or "configvar"
	chgParams, 			// parameter string to submit to server
	// following parameters allow the caller to customize the results page
	context,			// the catagory that is being changed "IP Bindings", "Mime Types", etc)
	resultsFunc,		// (optional) function for preprocessing the results array
	propStart			// (optional) starting property of the property path to display, default = 2 (omit "config.")
	/* EX: 
		property = "config.HTTPDeliverable.Path_1"
		propStart = 2
		display = "HTTPDeliverable.Path_1"
	*/
)
{
	dlgParams = new Object();
	var resultsFile = "config_results_" ;
	var options = defOptions + "yes" + dlgGetDimensons( resultsFile );

	resultsFile += ( isIE ? "ie" : "nav" ) + ".nc.html" ;
	dlgParams.isModal 		= true ;
	dlgParams.isOpen		= false ;
	dlgParams.userParams				= new Object();
	dlgParams.userParams.context		= context ;
	dlgParams.userParams.resultsFunc	= resultsFunc ;
	dlgParams.userParams.propStart		= propStart ;
	oldOnFocus = window.onfocus ;
	window.onfocus = doOnFocus ;
	//	PROCESS ARGS for bad things
	// strip off leading/trailing '&' seperators
	chgParams = chgParams.replace( /^&*/, '' );
	chgParams = chgParams.replace( /&*$/, '' );
	var url = "" ;
	if ( ( chgType == "configvar" ) ||
		 ( chgType == "servvar" ) )
	{
		url = chgType + ".set.html" ;
		// pass along the contextID so that we later associate 
		// each changes with the current page
		if ( contextID )
			chgParams += buildParam( "context", contextID );
		if ( chgType == "configvar" )
		{
			doPendingChanges();
		}
	}
	else
	{
		url = chgType ;
		// when a dialog opens the results window, close that dialog when
		// the results window is closed
		dlgParams.bCloseOpenerOnClose = true ;
	}
	url += "?respage=" + resultsFile + "&" + chgParams ;

	// already in the results window?
	if ( window.name != "_RESULTS" )
	{
		hwndDlg = window.open( url, "_RESULTS", options );
	}
	else
	{

		window.location = url ;
		hwndDlg = window ;
	}
	if ( hwndDlg ) hwndDlg.focus();
	return hwndDlg ;
}
function displayChanges ()
{
	var resultsFile = "config_pending_" ;
	var options = defOptions + "yes" + dlgGetDimensons( resultsFile );
	resultsFile += ( isIE ? "ie" : "nav" ) + ".nc.html" ;
	dlgParams 				= new Object();
	dlgParams.isModal 		= false ;
	dlgParams.isOpen		= false ;
	dlgParams.userParams	= new Object();
 	hwndDlg = window.open( resultsFile, "_CHANGES", options );
	if ( hwndDlg ) hwndDlg.focus();
}	// displayChanges ()

// results window is 'modal' - bounce focus back to it
function doOnFocus ( )
{
	if ( hwndDlg && (! hwndDlg.closed) && dlgParams.isOpen )
	{
		hwndDlg.focus();
	}
	else
	{
		dlgParams.isOpen = false ;
		window.onfocus = oldOnFocus ;
		oldOnFocus = null ;
		hwndDlg = null ;
		if ( dlgParams.bCloseOpenerOnClose )
		{
			window.close();
		}
	}
}
function raDialog
( 
	dialog,
	userParams,
	OKHandler,
	width,
	height
)
{
	dlgParams = new Object();
	var options = defOptions + "no" + dlgGetDimensons( dialog, width, height );

	// set standard dialog properties
	dlgParams.OKHandler  		= OKHandler ;
	dlgParams.isModal 			= true ;
	dlgParams.open				= false ;
	// setup user properties
	dlgParams.userParams		= userParams ;
	oldOnFocus = window.onfocus ;
	window.onfocus = doOnFocus ;
	// already in the "_DIALOG" window?
	var defName = "_DIALOG" ;
	if ( window.name == defName )
	{
		defName = "_DIALOG_" + dialog.replace( /\..*/, "" );
	}
	hwndDlg = window.open( dialog, defName, options );
	if ( hwndDlg ) hwndDlg.focus();
	return hwndDlg ;
}
function dlgGetDimensons ( dlg,	width, height )
{
	if ( ! (width && height) )
	{
		//strip off url query string
		dlg = dlg.replace( /\?.*/, "" );
		var aDim = dlgDimensions[ dlg.toLowerCase() ];
		if ( aDim == null )	// use defaults
		{
			width  = 460 ;
			height = 380 ;
		}
		else
		{
			if ( aDim.length == 1 )
				aDim = aDim[ 0 ];
			else if ( aDim.length == 2 )
				aDim = aDim[ (isIE ? 0 : 1) ];
			else
				aDim = aDim[ (isIE ? 0 : isWin ? 1 : 2) ];
			width  = aDim[ 0 ];
			height = aDim[ 1 ];
		}
	}
	return ",width=" + width + ",height=" + height +	
		getCenteredCoords( width, height );
}
dlgDimensions = new Array();
dlgDimensions[ 'edituserperm.html' ]	= [ [ 460, 380 ], [ 480, 420 ], [ 460, 500 ] ];
dlgDimensions[ 'grantuser.html' ]		= [ [ 480, 380 ], [ 480, 400 ], [ 460, 440 ] ];

dlgDimensions[ 'config_results_' ] 			= [ [ 600, 480 ] ];
dlgDimensions[ 'config_pending_' ] 			= [ [ 600, 540 ] ];
dlgDimensions[ 'prompt_' ] 					= [ [ 440, 210 ], [ 438, 208 ] ];
function getCenteredCoords ( width, height )
{
	// returns the X and Y coords to center a window with the given dimensions
	// return format is in window.open() style parameters
	return (
		",screenX=" + parseInt( (screen.width  - width)  / 2 ) +
		",screenY=" + parseInt( (screen.height - height) / 2 ) );
}

