<server language="JavaScript">
// BEGININC
<!--#INCLUDE file="server.inc" -->
// ENDINC

/* 
	get the pn-encoder list - we find this by finding the list 
	(which can be called anything) which has a property "ShortName" == "pn-live3" 
	or "pn-encoder", depending on which page is requesting the data (check the 
	parameters list for the page parameter). Note: we know the list is under the
	"config.FSMount" list.
*/

var shortName = "";
var page = RMAGetPropertyValue( "parameters.page" );
if ( page == "config_broadFSpre" )
	shortName = "pn-live3" ;
else if ( page == "config_broadFS" )
	shortName = "pn-encoder" ;
else if ( page == "config_broad_qt" )
	shortName = "pn-qtencoder" ;

var encoderList = findSubPropVal( "config.FSMount", "ShortName", shortName ).leftProp( -1 );
if ( encoderList == "" )
{
	RMAOutput( "var encoderList = new Array();\n" );
}
else
{
	emitPropsToJSArray( encoderList, "encoderList", 0, 0 );

	// add the list name to the array as the "Description" property
	emitArrayProp( "encoderList", "Description", encoderList.rightProp() );
}

if ( page != "config_broad_qt" )
{
	// for realms dropdown list
	emitPropsToJSArray( "config.AuthenticationRealms", "realmList", 0, 0 );
}

</server>


