<server language="JavaScript">
// BEGININC
<!--#INCLUDE file="server.inc" -->
// ENDINC

emitPropsToJSArray( "config.ISPHosting", "ispList", 0, 0 );

function findContentCallback( prop, val, curDepth )
{
	// ShortName must be "pn-local"
	if ( val != "pn-local" ) return ;

	// get parent property: should be mount point list name
	prop = prop.leftProp( -1 );

	// dbg( prop + "=" + val, 1 );

	// get the MountPoint property
	var mountPoint = RMAGetPropertyValue( prop + ".MountPoint" );
	if ( ! mountPoint )	
		return ;

	// if the mountPoint resembles an adminFS then skip it
	if ( -1 != mountPoint.search( /admin/i ) ) 
		return ;

	// if there's a baseMountPoint then skip it
	if ( RMAGetPropertyValue( prop + ".BaseMountPoint" ) )
		return ;

	//its a keeper!
	contentListNames[ contentListNames.length ] = prop ;
}

// build list of qualifying content mount points

var contentListNames = new Array();
findSubProp( "config.FSMount", "ShortName", findContentCallback, 0 );

RMAOutput( "var mountPoints = new Array();\n" );
var prop, arrayName ;
for ( var i = 0; i < contentListNames.length; i++ )
{
	prop = contentListNames[i];
	arrayName = "mountPoints[" + qVar( prop.rightProp() ) + "]" ;

	emitPropsToJSArray( prop, arrayName, 0, 0 );

	// add the list name to the sub array as the "Description" property
	emitArrayProp( arrayName, "Description", prop.rightProp() );
}

</server>

function getMountPointOptionList ()
{
	var s = "" ;
	var mp ;

	for ( var desc in mountPoints )
	{
		mp = mountPoints[ desc ][ 'MountPoint' ];
		s += '<option value="' + mp + '">' + mp ;
	}

	return s ;

}	// getMountPointOptionList

function addMountPointsToOptionList ( listCtrl )
{
	var mp ;
	listCtrl.options[ listCtrl.length ] = new Option( "Pick a Mount Point", "" );
	for ( var desc in mountPoints )
	{
		mp = mountPoints[ desc ][ 'MountPoint' ];
		listCtrl.options[ listCtrl.length ] = new Option( mp, mp );
	}

}	// addMountPointsToOptionList


